SystemOrganization addCategory: #ConfigurationOfKaliningrad!

Object subclass: #ConfigurationOfKaliningrad
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfKaliningrad'!

!ConfigurationOfKaliningrad class methodsFor: 'development support' stamp: 'dkh 9/21/2011 02:41'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfKaliningrad class methodsFor: 'private' stamp: 'dkh 9/21/2011 02:41'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfKaliningrad class methodsFor: 'private' stamp: 'dkh 9/21/2011 02:41'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfKaliningrad class methodsFor: 'private' stamp: 'dkh 9/21/2011 02:41'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfKaliningrad class methodsFor: 'metacello tool support' stamp: 'dkh 9/21/2011 02:41'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfKaliningrad class methodsFor: 'loading' stamp: 'dkh 9/21/2011 02:41'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfKaliningrad class methodsFor: 'loading' stamp: 'dkh 9/21/2011 02:41'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfKaliningrad class methodsFor: 'loading' stamp: 'dkh 9/21/2011 02:41'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfKaliningrad class methodsFor: 'accessing' stamp: 'dkh 9/21/2011 02:41'!
project

	^self new project! !

!ConfigurationOfKaliningrad class methodsFor: 'development support' stamp: 'dkh 9/21/2011 02:41'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfKaliningrad methodsFor: 'baselines' stamp: 'dkh 9/21/2011 02:42'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec 
			project: 'tODE' with: [
				spec
					className: 'ConfigurationOftODE';
					versionString: #'bleedingEdge';
					repository: 'http://ss3.gemstone.com/ss/tODE' ];
			project: 'SeasideRest' with: [
				spec
					className: 'ConfigurationOfSeasideRest';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec package: 'Kaliningrad-Core' with: [
				spec requires: #('tODE' 'SeasideRest' ). ]. ].
! !

!ConfigurationOfKaliningrad methodsFor: 'symbolic versions' stamp: 'dkh 9/21/2011 02:43'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfKaliningrad methodsFor: 'accessing' stamp: 'dkh 9/21/2011 02:41'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfKaliningrad methodsFor: 'versions' stamp: 'dkh 9/21/2011 11:42'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '0.1 (dkh.1):
- initial configuration
0.1 (dkh.2):
- tweak config
0.1 (dkh.3):
Amber 0.9 can be deployed from within a Seaside3.0 server ...'.
		spec author: 'dkh'.
		spec timestamp: '9/21/2011 11:42'.
		spec 
			project: 'tODE' with: '0.1';
			project: 'SeasideRest' with: '0.21'.
		spec package: 'Kaliningrad-Core' with: 'Kaliningrad-Core-dkh.2'. ].
! !
